#version 450

layout (set = 0, binding = 0) uniform Descriptor {
	vec4 background_color;
	vec4 border_color;

    uint width;
    uint height;
    uint border_thickness;
} descriptor;

layout (location = 0) out vec4 out_color;

void main()
{
    uint s = uint(gl_FragCoord.x);
    uint t = uint(gl_FragCoord.y);

    if (s < descriptor.border_thickness ||
        s >= (descriptor.width - descriptor.border_thickness) ||
        t < descriptor.border_thickness ||
        t >= (descriptor.height - descriptor.border_thickness))
    {
        out_color = descriptor.border_color;
    }
    else {
        out_color = descriptor.background_color;
    }
}
