mod update;

use update::update;

use proc_macro::TokenStream;
use syn::{
    LitInt, Result,
    parse::{Parse, ParseStream},
    parse_macro_input,
    token::Comma,
};

struct UpdateInfo {
    max_components: usize,
    max_resources: usize,
}

impl Parse for UpdateInfo {
    fn parse(input: ParseStream) -> Result<Self> {
        let max_components = input.parse::<LitInt>()?.base10_parse()?;
        input.parse::<Comma>()?;
        let max_resources = input.parse::<LitInt>()?.base10_parse()?;

        Ok(Self {
            max_components,
            max_resources,
        })
    }
}

#[proc_macro]
pub fn implement_callbacks(input: TokenStream) -> TokenStream {
    let input = parse_macro_input!(input as UpdateInfo);

    update(input.max_components, input.max_resources)
}
